#include<bits/stdc++.h>
using namespace std;

inline int read()
{
	int x=0;
	char c=getchar();
	while(c<'0'||c>'9') c=getchar();
	while(c>='0'&&c<='9')
	{
		x=x*10+c-'0';
		c=getchar();
	}
	return x;
}

int T,n,ans;
string s[2],t[2]; 

void workA()
{
	int ans=0;
	for(int i=0;i<n;i++) if(s[1][i]==s[0][0]) ans++;
	cout<<ans<<endl;
}

int main()
{
	freopen("edit.in","r",stdin);
	freopen("edit.out","w",stdout);
	T=read();
	while(T--)
	{
		n=read();
		cin>>s[0]>>s[1]>>t[0]>>t[1];
		if(n<=10)
		{
			bool c;
			int i; 
			for(i=n;i;i--)
			{
				c=1;
				for(int i=0;i<n;i++)
					if(s[0][i]!=s[1][i]&&t[0][i]==t[1][i]&&t[0][i]==0)
					{	
						c=0;break;
					}
				if(c){cout<<max(1,i-3)<<endl;break;}
			}
			if(!c) puts("0");
		}
		else
		{
			bool A=1;
			for(int i=1;i<n;i++)
				if(s[0][i]!=s[0][0])
				{
					A=0;break;
				}
			if(A)
			{
				workA();continue;
			}
			else puts("0");
		}
	}
}
